<template>
  <div>
    <div class="flex-table">
      <SubSubHeading title="New environment" />
      <div class="flex-row">
        <div class="flex-cell name-preset-cell">
          <div>Name</div>
          <input type="text" v-model="environmentName"/>
          <div>Type</div>
          <EnvironmentTypes :available-types="calcAvailableTypeList()" @select-type="setEnvironmentType" :selected-type="environmentType" />
        </div>
        <div class="flex-cell components-cell">
          <div>Customizations</div>
        </div>
      </div>
      <button @click="requestStart">Start</button>
    </div>
  </div>
</template>

<script setup>
import { ref, onMounted, defineEmits } from 'vue';
import EnvironmentTypes from './EnvironmentTypes.vue';
import SubSubHeading from './SubSubHeading.vue';

const emit = defineEmits(['refreshEnvironments'])

const availableEnvironmentTypes = ref([]);
const environmentName = ref('Fighting lemur');
const environmentType = ref(null);

const setEnvironmentType = (type) => {
  console.log("setEnvironmentType", type)
  environmentType.value = type;
};

function requestStart() {
  const data = {
    name: environmentName.value.replace(' ', '-'),
    components: [{
      name: environmentType.value,
      // a type value needs to be added to the catalyst manifest
      type: environmentType.value
    },],
  }
  console.log(data)
  fetch('/api/v0/environments', {
    method: "POST",
    headers: {
      "Content-Type": "application/json",
    },
    body: JSON.stringify(data),
  }).then(() => emit('refreshEnvironments'));
}

async function getAvailableTypes() {
  const context = import.meta.glob('../charts/**/catalyst.yaml');
  console.log(context);
  const availableTypes = [];
  let counter = 1;
  for (const path in context) {
    const module = await context[path]();
    const yaml = module.default;
    availableTypes.push(yaml);
  }
  console.log("availableTypes: ", availableTypes);
  return availableTypes;
}

function calcAvailableTypeList() {
  return availableEnvironmentTypes.value.map((type) => {
    return {
      name: type.metadata.name,
      label: type.metadata.label
    };
  });
}

onMounted(async () => {
  const fetchedPresets = await getAvailableTypes();
  availableEnvironmentTypes.value = fetchedPresets;
});

</script>

<style scoped>
.flex-table {
  display: flex;
  flex-direction: column;
  background-color: #eee;
  padding: 1.7em;
}

.flex-row {
  display: flex;
}

.flex-cell {
  padding: 0.5em;
}

.name-preset-cell {
  flex-basis: content;
  flex-grow: 0;
  flex-shrink: 0;
  display: flex;
  flex-direction: column;
  gap: 0.5em;
}

.components-cell {
  flex-grow: 1;
  margin-left: 3em;
}
</style>
